/***********************************************************
		Copyright IBM Corporation 1988

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of IBM not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/
/***********************************************************
Copyright 1989 by the Massachusetts Institute of Technology

                     All rights reserved.

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the Massachusetts
Institute of Technology (M.I.T.) not be used in advertising or publicity
pertaining to distribution of the software without specific, written
prior permission.

M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
M.I.T. BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/* $Header: /afs/athena.mit.edu/astaff/project/x11r5/src/athena/ibm/apa16/RCS/apa16RArea.c,v 5.0 1991/12/30 19:22:51 jfc Exp $ */
/* $Source: /afs/athena.mit.edu/astaff/project/x11r5/src/athena/ibm/apa16/RCS/apa16RArea.c,v $ */

#ifndef lint
static char *Id = "$Header: /afs/athena.mit.edu/astaff/project/x11r5/src/athena/ibm/apa16/RCS/apa16RArea.c,v 5.0 1991/12/30 19:22:51 jfc Exp $";
#endif

#include "X.h"
#include "scrnintstr.h"

#include "mfb.h"

#include "OScompiler.h"
#include "apa16Hdwr.h"

/* apa16 Replicate Area -- A Divide & Conquer Algorithm
 * an "apa16" Helper Function For Stipples And Tiling
 * P. Shupak 9/88
 * J. Carr 12/91
 */

void
apa16replicateArea( x, y, goalWidth, goalHeight, currentHoriz, currentVert )
register int x;
register int y;
register int goalWidth;
register int goalHeight;
register int currentHoriz;
register int currentVert;
{
	register int offset;
	register unsigned long int cmd;

	APA16_GET_CMD_COPY(ROP_RECT_COPY, GXcopy, cmd);
	cmd |= EXEC_MASK;
	/* reserve space for graphics commands:
	   max of 12 iterations * 2 dimensions * 7 words per command */
	RESERVE_QUEUE(168);

	for (;
	      (offset = currentHoriz << 1 ) <= goalWidth;
	      currentHoriz = offset ) {
		COPY_RECT_NOCHECK(cmd,  x + offset, y + currentVert,
				  x + currentHoriz, y + currentVert,
				  currentHoriz, currentVert);
	}
	if (offset = goalWidth - currentHoriz) {
		COPY_RECT_NOCHECK(cmd,  x + goalWidth, y + currentVert,
				  x + offset, y + currentVert,
				  offset, currentVert);
	}
	x += goalWidth; /* All Done For x dimension */
	for (;
	      (offset = currentVert << 1) <= goalHeight;
	      currentVert = offset) {
		COPY_RECT_NOCHECK(cmd, x, y + offset,x, y + currentVert,
				  goalWidth, currentVert);
	}
	if (offset = goalHeight - currentVert) {
	  COPY_RECT_NOCHECK(cmd, x, y + goalHeight,
			    x, y + offset, goalWidth, offset);
	}
}


